Index: trunk/biblioentry_xml.xsl
===================================================================
--- trunk/biblioentry_xml.xsl	(revision 63)
+++ trunk/biblioentry_xml.xsl	(revision 64)
@@ -13,4 +13,8 @@
 update :
 $Id$
+fplod 2008-05-07T09:06:53Z aedon.locean-ipsl.upmc.fr (Darwin)
+improvements for conference
+fplod 2008-05-06T09:35:00Z aedon.locean-ipsl.upmc.fr (Darwin)
+add category choices
 fplod 2008-04-29T15:41:56Z aedon.locean-ipsl.upmc.fr (Darwin)
 chgt for dbk5 in 
@@ -23,5 +27,5 @@
 fplod 2007-05-16T10:27:34Z aedon.locean-ipsl.upmc.fr (Darwin)
 remove biblioentry/date and publisher
-add  biblioentry/biblioset/biliomisc
+add biblioentry/biblioset/bibliomisc
 fplod 2007-05-15T07:37:46Z aedon.locean-ipsl.upmc.fr (Darwin)
 factorisation de biblioentry
@@ -34,4 +38,6 @@
 
 <xsl:include href="correction_db.xsl"/>
+<xsl:include href="category_form.xsl"/>
+<xsl:include href="message_lang.xsl"/>
 
 <xsl:template name="one_biblioentry">
@@ -52,6 +58,14 @@
     <xsl:text>, </xsl:text>
     <xsl:choose>
-     <xsl:when test="$my_biblioentry/descendant::d:biblioset">
+     <xsl:when test="$my_biblioentry/descendant::d:biblioset[@relation='journal']">
       <xsl:apply-templates select="$my_biblioentry/descendant::d:biblioset/child::d:title"/>
+      <xsl:if test="$my_biblioentry/descendant::d:publishername">
+       <xsl:text>, </xsl:text>
+       <xsl:apply-templates select="$my_biblioentry/descendant::d:publishername"/>
+      </xsl:if>
+      <xsl:if test="$my_biblioentry/descendant::d:publisher/d:address">
+       <xsl:text>, </xsl:text>
+       <xsl:apply-templates select="$my_biblioentry/descendant::d:publisher/d:address"/>
+      </xsl:if>
       <xsl:if test="$my_biblioentry/descendant::d:volumenum">
        <xsl:text>, </xsl:text>
@@ -70,13 +84,37 @@
       </xsl:if>
      </xsl:when>
+     <xsl:when test="$my_biblioentry/descendant::d:biblioset[@relation='conference']">
+      <xsl:apply-templates select="$my_biblioentry/descendant::d:biblioset/descendant::d:conftitle"/>
+      <xsl:if test="$my_biblioentry/descendant::d:biblioset/descendant::d:confnum">
+       <xsl:apply-templates select="$my_biblioentry/descendant::d:biblioset/descendant::d:confnum"/>
+      </xsl:if>
+      <xsl:text>, </xsl:text>
+      <xsl:apply-templates select="$my_biblioentry/descendant::d:biblioset/descendant::d:confdates"/>
+      <xsl:text>, </xsl:text>
+      <xsl:apply-templates select="$my_biblioentry/descendant::d:biblioset/descendant::d:address"/>
+      <xsl:text>, </xsl:text>
+      <xsl:apply-templates select="$my_biblioentry/descendant::d:biblioset/descendant::d:publishername"/>
+      <xsl:if test="$my_biblioentry/descendant::d:pagenums">
+       <xsl:text>, </xsl:text>
+       <xsl:apply-templates select="$my_biblioentry/descendant::d:pagenums"/>
+      </xsl:if>
+     </xsl:when>
      <xsl:otherwise>
-      <xsl:apply-templates select="$my_biblioentry/d:publishername"/>
+      <xsl:message terminate="no">
+eee : unknown biblioset relation for <xsl:value-of select="ancestor::d:biblioentry/@xml:id"/>
+eee : <xsl:value-of select="$my_biblioentry/descendant::d:biblioset/@relation"/>
+      </xsl:message>
+      <xsl:apply-templates select="$my_biblioentry/descendant::d:publishername"/>
      </xsl:otherwise>
     </xsl:choose>
     <xsl:apply-templates select="$my_biblioentry/d:biblioid"/>
-    <xsl:apply-templates select="$my_biblioentry/d:bibliomisc"/>
   </xsl:element>
   <xsl:if test="$visu_modif= 'modif'">
    <xsl:call-template name="correction">
+    <xsl:with-param name="id" select="$my_biblioentry/@xml:id"/>
+   </xsl:call-template>
+  </xsl:if>
+  <xsl:if test="$visu_modif= 'category'">
+   <xsl:call-template name="category">
     <xsl:with-param name="id" select="$my_biblioentry/@xml:id"/>
    </xsl:call-template>
@@ -129,5 +167,8 @@
    </xsl:when>
    <xsl:when test="count(following-sibling::*)  = 1">
-    <xsl:text> and </xsl:text> <!-- un suivant -->
+    <!-- un suivant -->
+    <xsl:call-template name="and">
+     <xsl:with-param name="language" select="/d:bibliography/@xml:lang"/>
+    </xsl:call-template>
    </xsl:when>
   </xsl:choose>
@@ -146,43 +187,59 @@
    </xsl:when>
   </xsl:choose>
-  <xsl:value-of select="."/>
+  <xsl:value-of select="normalize-space(.)"/>
 </xsl:template>
 <xsl:template match="d:biblioentry/d:title">
-  <xsl:value-of select="."/>
+  <xsl:value-of select="normalize-space(.)"/>
 </xsl:template>
 
 <xsl:template match="d:biblioset[@relation='journal']/d:title">
-  <xsl:value-of select="."/>
-</xsl:template>
+  <xsl:value-of select="normalize-space(.)"/>
+</xsl:template>
+
 <xsl:template match="d:publishername">
+  <xsl:value-of select="normalize-space(.)"/>
+</xsl:template>
+
+<xsl:template match="d:biblioset[@relation='journal']/d:pubdate">
+  <xsl:value-of select="normalize-space(.)"/>
+</xsl:template>
+<xsl:template match="d:biblioset[@relation='conference']/d:pubdate">
+  <xsl:value-of select="normalize-space(.)"/>
+</xsl:template>
+<xsl:template match="d:date">
  <xsl:message terminate="no">
-   eee : publishername 
-   <xsl:value-of select="."/> exists in node
+   eee : date 
+   <xsl:value-of select="normalize-space(.)"/> exists in node
    <xsl:value-of select="ancestor::d:biblioentry/@xml:id"/>
    eee : try to put information in biblioset
  </xsl:message>
 </xsl:template>
-<xsl:template match="d:biblioset[@relation='journal']/d:pubdate">
-  <xsl:value-of select="."/>
-</xsl:template>
-<xsl:template match="d:date">
- <xsl:message terminate="no">
-   eee : date 
-   <xsl:value-of select="."/> exists in node
-   <xsl:value-of select="ancestor::d:biblioentry/@xml:id"/>
-   eee : try to put information in biblioset
- </xsl:message>
-</xsl:template>
 
 <xsl:template match="d:biblioset[@relation='journal']/d:volumenum">
-  <xsl:value-of select="."/>
+  <xsl:value-of select="normalize-space(.)"/>
 </xsl:template>
 
 <xsl:template match="d:biblioset[@relation='journal']/d:issuenum">
-  <xsl:value-of select="."/>
+  <xsl:value-of select="normalize-space(.)"/>
 </xsl:template>
 
 <xsl:template match="d:biblioset[@relation='journal']/d:pagesnum">
-  <xsl:value-of select="."/>
+  <xsl:value-of select="normalize-space(.)"/>
+</xsl:template>
+
+<xsl:template match="d:biblioset[@relation='conference']/d:publisher/d:publishername">
+  <xsl:value-of select="normalize-space(.)"/>
+</xsl:template>
+<xsl:template match="d:conftitle">
+  <xsl:value-of select="normalize-space(.)"/>
+</xsl:template>
+<xsl:template match="d:confdates">
+  <xsl:value-of select="normalize-space(.)"/>
+</xsl:template>
+<xsl:template match="d:confnum">
+  <xsl:value-of select="normalize-space(.)"/>
+</xsl:template>
+<xsl:template match="d:address">
+  <xsl:value-of select="normalize-space(.)"/>
 </xsl:template>
 
@@ -203,15 +260,21 @@
    <xsl:attribute name="xl:href">
     <xsl:text>http://dx.doi.org/</xsl:text>
-    <xsl:value-of select="."/>
+    <xsl:value-of select="normalize-space(.)"/>
    </xsl:attribute>
-   doi:<xsl:value-of select="."/>
+   <xsl:text>doi:</xsl:text><xsl:value-of select="normalize-space(.)"/>
   </xsl:element>
  </xsl:otherwise>
  </xsl:choose>
 </xsl:when>
+<xsl:when test="@class='isbn'">
+ <xsl:text>, ISBN : </xsl:text><xsl:value-of select="normalize-space(.)"/>
+</xsl:when>
+<xsl:when test="@class='other'">
+ <xsl:text>, </xsl:text><xsl:value-of select="@otherclass"/><xsl:text> : </xsl:text><xsl:value-of select="normalize-space(.)"/>
+</xsl:when>
 <xsl:otherwise>
- <xsl:message>
-eee : unknown biblioid purpose for <xsl:value-of select="ancestor::d:biblioentry/@xml:id"/>
-eee : <xsl:value-of select="."/>
+ <xsl:message terminate="no">
+eee : unknown biblioid class for <xsl:value-of select="ancestor::d:biblioentry/@xml:id"/>
+eee : <xsl:value-of select="normalize-space(.)"/>
  </xsl:message>
 </xsl:otherwise>
@@ -223,22 +286,26 @@
 <xsl:when test="contains(.,'In Press')">
  <xsl:text>, </xsl:text>
- <xsl:value-of select="."/>
+ <xsl:value-of select="normalize-space(.)"/>
 </xsl:when>
 <xsl:when test="contains(.,'In press')">
  <xsl:text>, </xsl:text>
- <xsl:value-of select="."/>
+ <xsl:value-of select="normalize-space(.)"/>
 </xsl:when>
 <xsl:when test="contains(.,'in press')">
  <xsl:text>, </xsl:text>
- <xsl:value-of select="."/>
+ <xsl:value-of select="normalize-space(.)"/>
 </xsl:when>
 <xsl:when test="contains(.,'in revision')">
  <xsl:text>, </xsl:text>
- <xsl:value-of select="."/>
+ <xsl:value-of select="normalize-space(.)"/>
+</xsl:when>
+<xsl:when test="contains(.,'submitted')">
+ <xsl:text>, </xsl:text>
+ <xsl:value-of select="normalize-space(.)"/>
 </xsl:when>
 <xsl:otherwise>
  <xsl:message>
 eee : unknown bibliomisc purpose for <xsl:value-of select="ancestor::d:biblioentry/@xml:id"/>
-eee : <xsl:value-of select="."/>
+eee : <xsl:value-of select="normalize-space(.)"/>
  </xsl:message>
 </xsl:otherwise>
Index: trunk/bibopa.sh
===================================================================
--- trunk/bibopa.sh	(revision 63)
+++ trunk/bibopa.sh	(revision 64)
@@ -120,4 +120,5 @@
  exit 1
 fi
+unset status
 #
 # test if xml  is available
@@ -129,4 +130,5 @@
  exit 1
 fi
+unset status
 #
 usage=" Usage : ${command} -i filein -t type -p project -l lang"
@@ -143,4 +145,5 @@
    exit 1
 fi
+unset minargcount
 #
 while [ ! -z "${1}" ]
@@ -174,4 +177,5 @@
  shift # next flag
 done
+unset usage
 #
 set -u
@@ -220,101 +224,164 @@
 fi
 #
-jlist[1]="J. Climate"
-jlist[2]="Journal of Climate"
-jlist[3]="Ocean Modelling"
-jlist[4]="Geophys. Res. Lett."
-jlist[5]="J. Geophys. Res."
-jlist[6]="Tellus A"
-jlist[7]="Tellus B"
-jlist[8]="J. Phys. Oceanogr."
-jlist[9]="Clim. Dyn."
-jlist[10]="Climate Dynamics"
-jlist[11]="Dyn. Atmos. Oceans"
-jlist[12]="Mon. Wea. Rev."
-jlist[13]="Global Biogeochem. Cycles"
-jlist[14]="Nonlinear Processes in Geophysics"
-jlist[15]="Ocean Science"
-jlist[16]="J. Mar. Systems"
-jlist[17]="J. Atmos. Sc."
-jlist[18]="Proc. Royal Soc."
-jlist[19]="Bull. Amer. Meteorol. Soc."
-jlist[20]="Ocean Dyn."
-jlist[21]="Geophysical Monograph Series"
-jlist[22]="Paleoceanography"
-jlist[23]="Annales Geophysicae"
-jlist[24]="Annals of Geophys."
-jlist[25]="Deep Sea Research Part II: Topical Studies in Oceanography"
-jlist[26]="Deep Sea Res. II"
-jlist[27]="Atmospheric Chemistry and Physics"
-jlist[28]="Atmospheric Chemistry and Physics Discussions"
-jlist[29]="Earth Plan. Sc. Lett."
-jlist[30]="J. Mar. Res."
-jlist[31]="PCMDI Report Series"
-jlist[32]="J. Mar. Syst."
-jlist[33]="Note du Pole de Modelisation"
-jlist[34]="Calculateurs Paralleles"
-jlist[35]="Note Scientifique du Pole de Modelisation"
-jlist[36]="Lecture Notes in Computer Science"
-jlist[37]="Prog. Oceanogr."
-jlist[38]="Deep Sea Research Part I: Oceanographic Research Papers"
-jlist[39]="Deep Sea Res. I"
-jlist[40]="IEEE Trans. Geosci. Remote Sensing"
-jlist[41]="ECMWF Tech. Memorandum"
-jlist[42]="J. Environ. Radioactivity"
-jlist[43]="Int. WOCE Newsletter"
-jlist[44]="C. R. Acad. Sci. Paris"
-jlist[45]="C. R. Acad. Sci. Paris, Earth and Planetary Sciences"
-jlist[46]="In The mathematics of models for climatology and environment"
-jlist[47]="Oceanol. Acta"
-jlist[48]="The global atmosphere and ocean system"
-jlist[49]="NATO Advanced Study Institute"
-jlist[50]="WCRP"
-jlist[51]="The Courier"
-jlist[52]="Elsevier Oceanography Series"
-jlist[53]="In Conference Proceedings of the 1988 International Conference on Supercomputing"
-jlist[54]="In Science and engineering on Cray Supercomputers"
-jlist[55]="In Modeling the Earth's Climate and its Variability"
-jlist[56]="Fish. Oceanogr."
-jlist[57]="Q. J. R. Meteor. Soc."
-jlist[58]="In High performance computing in the geosciences"
-jlist[59]="Int. J. Numer. Meth. in Fluids"
-jlist[60]="Lecture notes in Physics"
-jlist[61]="J. Meterol. Soc. Japan"
-jlist[62]="Journal of Marine Systems"
-jlist[63]="Canadian Journal of Fisheries and Aquatic Sciences"
-jlist[64]="J. Atmos. Ocean. Tech."
-jlist[65]="EOS"
-jlist[66]="Nature"
-jlist[67]="Physics and Chemistry of the Earth, Part B: Hydrology, Oceans and Atmosphere"
-jlist[68]="Journal of Atmospheric and Oceanic Technology"
-jlist[69]="Lecture Notes in Computational Science Engineering"
-jlist[70]="In Greenhouse Gas Control Technologies"
-jlist[71]="Chemical Geology"
-jlist[72]="Marine Geology"
-jlist[73]="Developments in Paleoenvironmental Research"
-jlist[74]="Science"
-jlist[75]="In Mediterranean Climate Variability"
-jlist[76]="Global and Planetary Change"
-jlist[77]="Physical Review Letters"
-jlist[78]="Water Resour. Res."
-jlist[79]="Phil. Trans. Roy. Soc. A"
-jlist[80]="Theoretical and Applied Climatology"
-jlist[81]="Journal of Hydrometeorology"
-jlist[82]="Remote Sensing of Environment"
-jlist[83]="Progress In Oceanography"
-jlist[84]="Climatic Change"
-jlist[85]="Ocean Dynamics"
-jlist[86]="Izvestiya Atmospheric and Oceanic Physics"
-jlist[87]="Oceanology"
-jlist[88]="Advances in Atmospheric Sciences"
-jlist[89]="Quaternary Science Reviews"
-jlist[90]="AGU monograph"
+ij=1
+jlist[${ij}]="J. Climate"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Journal of Climate"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Ocean Modelling"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Geophys. Res. Lett."
+ij=$(( ${ij} + 1))
+jlist[${ij}]="J. Geophys. Res."
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Tellus A"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Tellus B"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="J. Phys. Oceanogr."
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Clim. Dyn."
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Climate Dynamics"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Dyn. Atmos. Oceans"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Mon. Wea. Rev."
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Global Biogeochem. Cycles"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Nonlinear Processes in Geophysics"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Ocean Science"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="J. Mar. Systems"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="J. Atmos. Sc."
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Proc. Royal Soc."
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Bull. Amer. Meteorol. Soc."
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Ocean Dyn."
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Geophysical Monograph Series"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Paleoceanography"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Annales Geophysicae"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Annals of Geophys."
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Deep Sea Research Part II: Topical Studies in Oceanography"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Deep Sea Res. II"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Atmospheric Chemistry and Physics"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Atmospheric Chemistry and Physics Discussions"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Earth Plan. Sc. Lett."
+ij=$(( ${ij} + 1))
+jlist[${ij}]="J. Mar. Res."
+ij=$(( ${ij} + 1))
+jlist[${ij}]="PCMDI Report Series"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="J. Mar. Syst."
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Note du Pole de Modelisation"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Calculateurs Paralleles"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Note Scientifique du Pole de Modelisation"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Lecture Notes in Computer Science"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Prog. Oceanogr."
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Deep Sea Research Part I: Oceanographic Research Papers"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Deep Sea Res. I"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="IEEE Trans. Geosci. Remote Sensing"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="ECMWF Tech. Memorandum"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="J. Environ. Radioactivity"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Int. WOCE Newsletter"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="C. R. Acad. Sci. Paris"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="C. R. Acad. Sci. Paris, Earth and Planetary Sciences"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="In The mathematics of models for climatology and environment"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Oceanol. Acta"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="The global atmosphere and ocean system"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="NATO Advanced Study Institute"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="WCRP"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="The Courier"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Elsevier Oceanographic Series"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="In Conference Proceedings of the 1988 International Conference on Supercomputing"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="In Science and engineering on Cray Supercomputers"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="In Modeling the Earth's Climate and its Variability"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Fish. Oceanogr."
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Q. J. R. Meteor. Soc."
+ij=$(( ${ij} + 1))
+jlist[${ij}]="In High performance computing in the geosciences"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Int. J. Numer. Meth. in Fluids"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Lecture notes in Physics"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="J. Meterol. Soc. Japan"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Journal of Marine Systems"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Canadian Journal of Fisheries and Aquatic Sciences"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="J. Atmos. Ocean. Tech."
+ij=$(( ${ij} + 1))
+jlist[${ij}]="EOS"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Nature"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Physics and Chemistry of the Earth, Part B: Hydrology, Oceans and Atmosphere"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Journal of Atmospheric and Oceanic Technology"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Lecture Notes in Computational Science Engineering"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="In Greenhouse Gas Control Technologies"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Chemical Geology"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Marine Geology"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Developments in Paleoenvironmental Research"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Science"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="In Mediterranean Climate Variability"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Global and Planetary Change"
+ij=$(( ${ij} + 1))
+jlist[${ij}]="Physical Review Letters"
 #
 # following Journal name are fake ones for demo1 : references extracted from
 # Cantratrix Sopronica L. written by Georges Perec
 #find in http://www-rocq.inria.fr/who/Marc.Thiriet/PsFil/Biblio/cantatrix.ps
-ij=90
-ij=$(( ${ij} + 1))
-jlist[$ij]="Res. Proc. neurophysiol. Fanatic Soc"
+ij=$(( ${ij} + 1))
+jlist[$ij]="Res. Proc. neurophysiol. Fanatic Soc."
 ij=$(( ${ij} + 1))
 jlist[$ij]="New Records Ass. J."
@@ -333,6 +400,4 @@
 ij=$(( ${ij} + 1))
 jlist[$ij]="Amer. J. music. Deciency"
-#jlist[]=""
-#
 #
     cat <<EOF > ${fileou}
@@ -348,4 +413,5 @@
 </info>
 EOF
+unset lang
 #
 # strip comments
@@ -523,16 +589,18 @@
     do
     ok=$( echo ${endline} | grep -ci "${jlist[j]} *," )
-    [ $ok -eq 1 ] && jfound="${jlist[j]}"
+    [ ${ok} -eq 1 ] && jfound="${jlist[j]}"
     j=$(( ${j} + 1 ))
   done
+  unset ok
   if [ "${jfound}" == "" ]
       then
       echo "eee: Journal not found "
       echo "${endline}"
+      #++set
       #++exit 1
 #+++ following lines are not yet validate
       # it might be a book, a manual, a conference, etc. ++
       echo "  <title>${title}</title>" >> ${fileou}
-      echo "  <biblioid class=\"isbn\">${isbn}</biblioid>" >> ${fileou}
+      #++echo "  <biblioid class=\"isbn\">${isbn}</biblioid>" >> ${fileou}
 	  cat <<EOF >> ${fileou}
   <biblioset relation="nojournal">
@@ -565,4 +633,5 @@
       doi=${endline##*doi:}
       echo "  <biblioid class=\"doi\">${doi}</biblioid>" >> ${fileou}
+      unset doi
       endline=${endline%doi:*}
       endline=$( cleanname "${endline}" )
@@ -596,5 +665,5 @@
 	  pag=$( cleanname "${pag}" )
 	  cat <<EOF >> ${fileou}
-  <biblioset role="journal">
+  <biblioset relation="journal">
     <title>${jfound}</title>
     <volumenum>${vol}</volumenum><issuenum>${iss}</issuenum><pagenums>${pag}</pagenums>
@@ -606,5 +675,5 @@
 #echo ${num}: ${endline} # ++debug
 	  cat <<EOF >> ${fileou}
-  <biblioset role="journal">
+  <biblioset relation="journal">
     <title>${jfound}</title>
     <pubdate>${year}</pubdate>
@@ -627,4 +696,6 @@
 
 done
+unset totlines
+unset l
 echo "</bibliography>" >> ${fileou}
 
Index: trunk/mailtouser.sh
===================================================================
--- trunk/mailtouser.sh	(revision 64)
+++ trunk/mailtouser.sh	(revision 64)
@@ -0,0 +1,324 @@
+#! /bin/sh
+#
+# module :
+# convert email text in xml form folloowing user.dtd
+#
+# see also bibopa.sh
+#
+# example :
+# $ ./mailtouser.sh -m data/mail2007-05-10T09:01:56Z -x ginette.xml
+#
+# see also bibopa.sh
+#
+# update :
+# ++ gestion des comments
+# ++ gestion de la signature
+# $Id$
+# fplod 2007-06-06T09:27:55Z aedon.locean-ipsl.upmc.fr (Darwin)
+# correction for Off-Line and PC Cluster
+# fplod 2007-05-18T08:31:48Z aedon.locean-ipsl.upmc.fr (Darwin)
+# add off-line and agrif components
+# fplod 2007-05-09T15:03:15Z aedon.locean-ipsl.upmc.fr (Darwin)
+# reprise + ajout middlename + ajout components_date
+# fplod 2007-04-25T09:15:38Z aedon.locean-ipsl.upmc.fr (Darwin)
+# creation
+#
+set -o posix
+command=$(basename ${0} .sh)
+log_date=$(date -u +"%Y-%m-%dT%H:%M:%SZ")
+log=/tmp/${command}.${log_date}
+#
+usage=" Usage : ${command} -m mailbodyfile -x xmloutput"
+#
+# test if xmllint is available
+type xmllint 1> /dev/null 2>&1
+status=${?}
+if [ ${status} -ne 0 ]
+then
+ echo " eee : xmllint not found"
+ exit 1
+fi
+#
+# check for user.dtd
+if [ ! -f user.dtd ]
+then
+  echo "eee : user.dtd not found"
+  exit 1
+fi
+#
+while [ ! -z "${1}" ] # ++ pb bash
+do
+ case ${1} in
+ -m) # mailbodyfile
+  mailbodyfile=${2}
+  shift
+ ;;
+ -x) # xmloutput
+  xmloutput=${2}
+  shift
+ ;;
+ *) # other choice
+  echo "${usage}"
+  exit 1
+ ;;
+ esac
+ shift # next flag
+done
+#
+set -u
+#
+# check for mailbodyfile
+if [ ! -f ${mailbodyfile} ]
+then
+  echo "eee : ${mailbodyfile} not found"
+  exit 1
+fi
+#
+# check for xmloutput
+#++ err si exist
+#
+echo "<user>" > ${xmloutput}
+echo "<!-- mailbodyfile : ${mailbodyfile} " >> ${xmloutput}
+cat ${mailbodyfile} >> ${xmloutput}
+echo "-->" >> ${xmloutput}
+echo "<!-- ${log_date} -->" >> ${xmloutput}
+author_id=$(grep "author_id=" ${mailbodyfile} | awk -F"=" '{print $2}')
+surname=$(grep "personal_surname=" ${mailbodyfile} | awk -F"=" '{print $2}')
+firstname=$(grep "personal_firstname=" ${mailbodyfile} | awk -F"=" '{print $2}')
+middlename=$(grep "personal_middlename=" ${mailbodyfile} | awk -F"=" '{print $2}')
+if [ "${author_id}" = "template" ]
+then
+ author_id=$( echo ${surname} | \
+ tr "[:lower:]" "[:upper:]" | \
+ tr " " "_"  | \
+ recode -d -f UTF-8..flat)
+ author_id=${author_id}_$( echo ${firstname:0:1} | \
+ tr "[:upper:]" "[:lower:]" | \
+ recode -d -f UTF-8..flat)
+fi
+echo "<userid>${author_id}</userid>" >> ${xmloutput}
+#
+echo "<personname>" >> ${xmloutput}
+#
+echo "<surname>$surname</surname>" >> ${xmloutput}
+#
+echo "<firstname>$firstname</firstname>" >> ${xmloutput}
+echo "<othername role='mi'>$middlename</othername>" >> ${xmloutput}
+#
+echo "</personname>" >> ${xmloutput}
+#
+email=$(grep "personal_email=" ${mailbodyfile} | awk -F"=" '{print $2}')
+echo "<email>$email</email>" >> ${xmloutput}
+#
+elements=components
+element=component
+#++ récupérer les users/user[child::userid='template']/components/component/name
+unset jlist
+unset jlist_name
+j=1
+jlist[${j}]="OPA"
+jlist_name[${j}]="OPA"
+j=$((${j} + 1))
+jlist[${j}]="LIM"
+jlist_name[${j}]="LIM"
+j=$((${j} + 1))
+jlist[${j}]="TOP"
+jlist_name[${j}]="TOP"
+j=$((${j} + 1))
+jlist[${j}]="TAM"
+jlist_name[${j}]="TAM"
+j=$((${j} + 1))
+jlist[${j}]="SAXO"
+jlist_name[${j}]="SAXO"
+j=$((${j} + 1))
+jlist[${j}]="offline"
+jlist_name[${j}]="Off-line"
+j=$((${j} + 1))
+jlist[${j}]="AGRIF"
+jlist_name[${j}]="AGRIF"
+echo "<${elements}>" >> ${xmloutput}
+components_date=$(grep "components_date=" ${mailbodyfile} | awk -F"=" '{print $2}')
+echo "<components_date>$components_date</components_date>" >> ${xmloutput}
+## find the element
+j=1
+jlistsize=${#jlist[@]}
+while [ ${j} -le ${jlistsize} ]
+do
+  jlist_min=$(echo ${jlist[j]} | tr [:upper:] [:lower:])
+  # recherche de ${jlist[j]}
+  grep -q "${element}_${jlist_min}" ${mailbodyfile}
+  ok=${?}
+  if [ ${ok} -eq 0 ]
+  then
+     echo "<${element} code='${jlist_min}'>" >> ${xmloutput}
+     echo "<name>${jlist_name[j]}</name>" >> ${xmloutput}
+     echo "<value>yes</value>" >> ${xmloutput}
+     echo "</${element}>"  >> ${xmloutput}
+  else
+     echo "<${element} code='${jlist_min}'>" >> ${xmloutput}
+     echo "<name>${jlist_name[j]}</name>" >> ${xmloutput}
+     echo "<value>no</value>" >> ${xmloutput}
+     echo "</${element}>"  >> ${xmloutput}
+  fi
+  j=$(( $j + 1 ))
+done
+echo "</${elements}>" >> ${xmloutput}
+#
+element=platform
+elements=platforms
+#++ récupérer les users/user[child::userid='template']/platforms/platform/name
+unset jlist
+unset jlist_name
+j=1
+jlist[${j}]="CRAY"
+jlist_name[${j}]="CRAY"
+j=$((${j} + 1))
+jlist[${j}]="IBM"
+jlist_name[${j}]="IBM"
+j=$((${j} + 1))
+jlist[${j}]="FUJITSU"
+jlist_name[${j}]="FUJITSU"
+j=$((${j} + 1))
+jlist[${j}]="MAC"
+jlist_name[${j}]="MAC"
+j=$((${j} + 1))
+jlist[${j}]="NEC"
+jlist_name[${j}]="NEC"
+j=$((${j} + 1))
+jlist[${j}]="SGI"
+jlist_name[${j}]="SGI"
+j=$((${j} + 1))
+jlist[${j}]="SUN"
+jlist_name[${j}]="SUN"
+j=$((${j} + 1))
+jlist[${j}]='pccluster'
+jlist_name[${j}]="PC Cluster"
+echo "<${elements}>" >> ${xmloutput}
+## find the element
+j=1
+jlistsize=${#jlist[@]}
+while [ ${j} -le ${jlistsize} ]
+do
+  # recherche de ${jlist[j]}
+  jlist_min=$(echo ${jlist[j]} | tr [:upper:] [:lower:])
+  grep -q "${element}_${jlist_min}" ${mailbodyfile}
+  ok=${?}
+  if [ ${ok} -eq 0 ]
+  then
+     echo "<${element} code='${jlist_min}'>" >> ${xmloutput}
+     echo "<name>${jlist_name[j]}</name>" >> ${xmloutput}
+     echo "<value>yes</value>" >> ${xmloutput}
+     echo "</${element}>"  >> ${xmloutput}
+  else
+     echo "<${element} code='${jlist_min}'>" >> ${xmloutput}
+     echo "<name>${jlist_name[j]}</name>" >> ${xmloutput}
+     echo "<value>no</value>" >> ${xmloutput}
+     echo "</${element}>"  >> ${xmloutput}
+  fi
+  j=$(( $j + 1 ))
+done
+#
+# gestion des "others"
+j=1
+jlistsize=${#jlist[@]}
+grep_cmd="grep ${element}_zzz_other ${mailbodyfile} "
+while [ ${j} -le ${jlistsize} ]
+do
+  grep_cmd="${grep_cmd} | grep -v ${element}=${jlist[j]}" #++ -v inutile
+  j=$(( $j + 1 ))
+done
+other=$(eval ${grep_cmd} | awk -F "=" '{print$2}')
+echo "<${element} code='zzz_other'>" >> ${xmloutput}
+echo "<name>Other</name>" >> ${xmloutput}
+echo "<value>${other}</value>" >> ${xmloutput}
+echo "</${element}>"  >> ${xmloutput}
+echo "</${elements}>" >> ${xmloutput}
+#
+processors=$(grep "processors=" ${mailbodyfile} | awk -F"=" '{print $2}')
+echo "<processors>$processors</processors>" >> ${xmloutput}
+#
+element=compiler
+elements=compilers
+unset jlist
+unset jlist_name
+j=1
+jlist[${j}]="g95"
+jlist_name[${j}]="g95"
+j=$((${j} + 1))
+jlist[${j}]="ifort"
+jlist_name[${j}]="ifort"
+j=$((${j} + 1))
+jlist[${j}]="pgf"
+jlist_name[${j}]="pgf"
+j=$((${j} + 1))
+jlist[${j}]="sxf90"
+jlist_name[${j}]="sxf90"
+j=$((${j} + 1))
+jlist[${j}]="xlf"
+jlist_name[${j}]="xlf"
+echo "<${elements}>" >> ${xmloutput}
+## find the element
+j=1
+jlistsize=${#jlist[@]}
+while [ ${j} -le ${jlistsize} ]
+do
+  # recherche de ${jlist[j]}
+  jlist_min=$(echo ${jlist[j]} | tr [:upper:] [:lower:])
+  grep -q "${element}_${jlist_min}" ${mailbodyfile}
+  ok=${?}
+  if [ ${ok} -eq 0 ]
+  then
+     echo "<${element} code='${jlist_min}'>" >> ${xmloutput}
+     echo "<name>${jlist_name[j]}</name>" >> ${xmloutput}
+     echo "<value>yes</value>" >> ${xmloutput}
+     echo "</${element}>"  >> ${xmloutput}
+  else
+     echo "<${element} code='${jlist_min}'>" >> ${xmloutput}
+     echo "<name>${jlist_name[j]}</name>" >> ${xmloutput}
+     echo "<value>no</value>" >> ${xmloutput}
+     echo "</${element}>"  >> ${xmloutput}
+  fi
+  j=$(( $j + 1 ))
+done
+#
+# gestion des "others"
+j=1
+jlistsize=${#jlist[@]}
+grep_cmd="grep ${element}_zzz_other= ${mailbodyfile} "
+while [ ${j} -le ${jlistsize} ]
+do
+  grep_cmd="${grep_cmd} | grep -v ${element}=${jlist[j]}" #++ -v inutile
+  j=$(( $j + 1 ))
+done
+other=$(eval ${grep_cmd} | awk -F "=" '{print$2}')
+echo "<${element} code='zzz_other'>" >> ${xmloutput}
+echo "<name>Other</name>" >> ${xmloutput}
+echo "<value>${other}</value>" >> ${xmloutput}
+echo "</${element}>"  >> ${xmloutput}
+echo "</${elements}>" >> ${xmloutput}
+#
+echo "</user>" >> ${xmloutput}
+#
+xmloutputfull=/tmp/${xmloutput} # ++
+echo '<?xml version="1.0" encoding="iso-8859-1"?>' > ${xmloutputfull}
+echo '<!DOCTYPE users SYSTEM "user.dtd">' >> ${xmloutputfull}
+echo '<users>' >> ${xmloutputfull}
+echo '<date>bidon</date>' >> ${xmloutputfull}
+cat ${xmloutput} >> ${xmloutputfull}
+echo '</users>' >> ${xmloutputfull}
+#
+# ++ parce que je ne sais pas dire où est la dtd dans la commande xmllint
+cp user.dtd /tmp/
+xmllint --noout --valid ${xmloutputfull} 1>> ${log} 2>> ${log}
+status=${?}
+if [ ${status} -ne 0 ]
+then
+ echo " eee : pb DTD conformance of ${xmloutputfull}"
+ echo " eee : see ${log}"
+ exit 1
+else
+ echo " iii : you can include ${xmloutput} in user.xml" #++ filename path
+ echo " iii : modify date in user.xml" #++ filename path
+fi
+#
+exit 0
